<template>
  <div class="no-hide">
    <column class="account-page account-container">
      <loader :data="account" :error="error" :retry="fetch">
        <div v-if="subscribed">
          <h4>Thanks for subscribing!</h4>
          <p>You may cancel or change your subscription below.</p>
          <p>
            For support, email me at
            <a href="mailto:dstaudigel@gmail.com">dstaudigel@gmail.com</a>
          </p>
          <hr />
        </div>

        <div v-else>
          <h3>Why Subscribe?</h3>
          <p>
            Right now, there are no "pro" features - we're just getting started!
            However, if you love orienteer and want to see it grow, kick us a
            few bucks and let us know what features you wanted added!
          </p>
        </div>

        <row v-if="!subscribingTo" class="plans padding-between">
          <cell
            v-for="(plan, index) in plans"
            :key="index"
            :class="{
              active:
                account.subscription && plan.id == account.subscription.plan.id,
            }"
          >
            <h3>{{ plan.nickname }}</h3>
            <h4>${{ (plan.amount / 100).toFixed(2) }}/{{ plan.interval }}</h4>

            <stateful-button
              v-if="subscribedTo(plan)"
              :click="unsubscribeFromCb(plan.id)"
              >Unsubscribe</stateful-button
            >
            <stateful-button v-else :click="subscribeToCb(plan.id)"
              >Subscribe</stateful-button
            >
          </cell>
        </row>

        <!-- TODO: Fix this. <div v-if="!account.subscription && account.default_source">
          <stateful-button :click="deleteSource"
            >Delete my Payment Method</stateful-button
          >
        </div> -->
        <column class="centered" v-if="subscribingTo">
          <h4>Please give us your payment details:</h4>
          <stripe-card
            class="stripe-card"
            :class="{ complete }"
            :stripe="stripePublishableKey"
            :options="stripeOptions"
            @change="complete = $event.complete"
          />
          <p>Payment secured by <a href="https://stripe.com">Stripe</a></p>
          <stateful-button
            class="pay-with-stripe"
            :click="pay"
            :disabled="!complete"
            >Pay with credit card</stateful-button
          >
        </column>
      </loader>
      <a style="margin-top: 20px" href="/logout">Log out</a>
    </column>
  </div>
</template>
<style lang="scss">
@import "~assets/mixins";

.main-nuxt {
  max-height: 100%;
}

.main-nuxt > .account-container {
  width: 100%;
  height: 100%;
  max-height: 100%;
  max-width: 100%;
}

.account-page {
  align-items: center;
  pointer-events: initial;

  > * {
    max-width: $grid * 20;
  }

  .plans {
    max-width: 100%;

    .plan {
      border: 1px gray solid;
      corner-radius: $grid * 0.5;
      padding: $grid * 0.5;
    }
  }
}

.stripe-card {
  min-width: $grid * 20;
  padding: $grid * 0.5;
  background-color: $color-white;
  border-radius: $grid * 0.5;
  border: $border;
}
</style>
<script>
import { Card, createToken } from "vue-stripe-elements-plus";
import { query } from "~/plugins/data-management";

const ACCOUNT_FIELDS = `
    default_source
    subscription {
      id current_period_end status
      plan { 
        id nickname active interval metadata amount
      }
    }
`;

const ACCOUNT_QUERY = `
query {
  account:getStripeAccount {
    ${ACCOUNT_FIELDS}
  }
  plans:allStripePlans {
    id nickname metadata amount interval
  }
}
`;

const SUBSCRIBE_MUTATION = `
mutation($token:String,$planId:String!){_:stripeSubscribe(token:$token planId:$planId){
${ACCOUNT_FIELDS}
}}
`;

const UNSUBSCRIBE_MUTATION = `
mutation($subscriptionId:String $planId:String){_:stripeUnsubscribe(subscriptionId:$subscriptionId,planId: $planId){
${ACCOUNT_FIELDS}
}}
`;

const SET_SOURCE_MUTATION = `
mutation($token:String!) { _: createDefaultSource(token: $token) {
${ACCOUNT_FIELDS}
}}`;

const DELETE_SOURCE_MUTATION = `
mutation { _ : deleteDefaultSource {
${ACCOUNT_FIELDS}
}}
`;

export default {
  asyncData: query(ACCOUNT_QUERY),
  data() {
    return {
      complete: false,
      error: null,

      subscribingTo: null,
      token: null,

      stripeOptions: {
        // see https://stripe.com/docs/stripe.js#element-options for details
      },
    };
  },

  components: { "stripe-card": Card },
  computed: {
    subscribed() {
      return !!this.account.subscription;
    },
    hasSource() {
      return this.account.default_source;
    },
    stripePublishableKey() {
      return this.$store.state.env.STRIPE_PUBLISHABLE_KEY;
    },
  },

  methods: {
    fetch() {
      return this.execute(ACCOUNT_QUERY);
    },
    subscribedTo(plan) {
      return (
        this.account.subscription &&
        plan.id == this.account.subscription.plan.id
      );
    },
    pay() {
      // createToken returns a Promise which resolves in a result object with
      // either a token or an error key.
      // See https://stripe.com/docs/api#tokens for the token object.
      // See https://stripe.com/docs/api#errors for the error object.
      // More general https://stripe.com/docs/stripe.js#stripe-create-token.
      return createToken().then((data) => {
        if (this.subscribingTo) {
          return this.finishSubscribe(data.token.id);
        } else {
          return this.execute(SET_SOURCE_MUTATION, { token: data.token.id });
        }
      });
    },
    async execute(query, args) {
      this.error = null;

      let { result, error } = await this.$gql(query, args);

      if (error) this.error = error;
      else this.account = result._ || result.account;
    },
    deleteSource() {
      return this.execute(DELETE_SOURCE_MUTATION);
    },
    async finishSubscribe(token) {
      await this.execute(SUBSCRIBE_MUTATION, {
        token,
        planId: this.subscribingTo,
      });

      this.token = null;
      this.subscribingTo = null;
    },
    subscribeToCb(planId) {
      return async () => {
        if (this.hasSource) {
          return this.execute(SUBSCRIBE_MUTATION, { planId });
        } else {
          this.subscribingTo = planId;
        }
      };
    },
    unsubscribeFromCb(planId) {
      return () => this.execute(UNSUBSCRIBE_MUTATION, { planId });
    },
  },
};
</script>
